%define gcc_branch 3.2

Name: gcc%gcc_branch
Version: 3.2.1
Release: alt2

Summary: GNU Compiler Collection
License: GPL
Group: Development/C
Url: http://gcc.gnu.org/
Packager: GCC Development Team <gcc@packages.altlinux.org>

%define priority 30
%define snapshot 20021119
%undefine snapshot
%define srcfilename gcc-%{?snapshot:%gcc_branch-%snapshot}%{!?snapshot:%version}
%define srcdirname gcc-%{?snapshot:%gcc_branch-%snapshot}%{!?snapshot:%version}
%define os_release %distribution, build %version-%release
%define psuffix -%gcc_branch
%define gcc_target_dir %_libdir/gcc-lib/%_target_platform/%version
%define gcc_doc_dir %_docdir/gcc%psuffix

# Build parameters.
%def_disable debug
%def_with fortran
%def_with objc
%def_with java
%def_without testsuite
%def_without pdf

Source: %srcfilename.tar.bz2

# RH patches
Patch1: gcc32-2.96-RH-compat.patch
Patch2: gcc32-boehm-gc-libs.patch
Patch3: gcc32-bogus-inline.patch
Patch6: gcc32-fde-merge-compat.patch
Patch7: gcc32-attr-visibility.patch
Patch8: gcc32-attr-visibility2.patch
Patch9: gcc32-duplicate-decl.patch
#Patch10: gcc32-trunc_int_for_mode.patch
Patch11: gcc32-sparc-sll1.patch
#Patch12: gcc32-x86_64-q_regs_operand.patch
Patch13: gcc32-dwarf2-pr6381.patch
Patch14: gcc32-dwarf2-pr6436-test.patch
Patch15: gcc32-c++-pretty_function.patch
Patch16: gcc32-c++-tsubst-asm.patch
Patch18: gcc32-i386-memtest-test.patch
#Patch19: gcc32-fold-const2.patch
Patch21: gcc32-ada-addr2line.patch
Patch22: gcc32-ada-link.patch
Patch23: gcc32-java-no-rpath.patch
Patch25: gcc32-s390-java.patch
Patch26: gcc32-test-rotate.patch
Patch27: gcc32-x86_64-libiberty-pic.patch
Patch29: gcc32-test-rh65771.patch
Patch30: gcc32-i386-default-momit-leaf-frame-pointer.patch
Patch31: gcc32-i386-pic-label-thunk.patch
Patch34: gcc32-pr6842.patch
Patch35: gcc32-tls.patch
Patch36: gcc32-i386-profile-olfp.patch
Patch37: gcc32-tree-code.patch
Patch38: gcc32-hard-reg-sharing.patch
Patch39: gcc32-hard-reg-sharing2.patch
Patch40: gcc32-c++-nrv-test.patch
Patch41: gcc32-debug-pr7241.patch
#Patch42: gcc32-i386-pr7242.patch
Patch43: gcc32-cfg-eh.patch
Patch44: gcc32-attr-visibility3.patch
Patch45: gcc32-tls2.patch
Patch46: gcc32-fold-const-associate.patch
Patch47: gcc32-inline-label.patch
Patch48: gcc32-typeof-asm.patch
#Patch50: gcc32-rh69989.patch
Patch51: gcc32-tls3.patch
Patch52: gcc32-tls4.patch
Patch54: gcc32-tls5.patch
Patch55: gcc32-tls-dwarf2.patch
Patch56: gcc32-x86_64-pr7559.patch
#Patch57: gcc32-loop-prefetch.patch
Patch58: gcc32-doc-gcov.patch
Patch59: gcc32-attr-visibility4.patch
Patch60: gcc32-c++-tail-pad-backout.patch
Patch61: gcc32-attr-visibility5.patch
Patch62: gcc32-i386-no-default-momit-leaf-frame-pointer.patch
Patch64: gcc32-x86_64-rip-lowercase.patch
#Patch65: gcc32-libstdc++-glibc23-1.patch
#Patch66: gcc32-libstdc++-glibc23-2.patch
#Patch67: gcc32-libstdc++-glibc23-3.patch
#Patch68: gcc32-libstdc++-glibc23-4.patch
#Patch69: gcc32-interface_only.patch

# SuSE patches.
Patch501: gcc31-DESTDIR.patch

# MDK patches.
# Strip ".." components when prior dir doesn't exist (Alan Modra)
Patch601: gcc32-strip-dotdot.patch

# ALT patches
Patch701: gcc32-alt-libobjc_makefile.patch
Patch702: gcc32-alt-install.patch
Patch703: gcc32-alt-nowrap.patch

Provides: gcc = %version-%release, %_bindir/%_target_platform-gcc, %_bindir/gcc
Obsoletes: egcs, gcc3.0, gcc3.1
Conflicts: glibc-devel < 2.2.6
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: cpp%gcc_branch = %version-%release, libgcc%gcc_branch = %version-%release
Requires: %{get_dep binutils}, glibc-devel, make >= 3.79.1

BuildPreReq: rpm-build >= 4.0.4-alt3, autoconf = 2.13, binutils >= 2.13.90.0.4, /bin/readlink, zlib-devel, glibc-devel-static
%{?_with_pdf:BuildPreReq: tetex-dvips}
%{?_with_testsuite:BuildPreReq: dejagnu}

%description
This package contains the GNU Compiler Collection version %version.
You'll need this package in order to compile C code.
It is also required for all other GCC compilers, namely C++,
Fortran 77, Objective C and Java.

If you have multiple versions of the GNU Compiler Collection
installed on your system, you will have to type
gcc%psuffix
in order to explicitly use the GNU C compiler version %version.

####################################################################
# GCC library

%package -n libgcc%gcc_branch
Summary: GNU GCC library
Group: System/Libraries
Provides: libgcc = %version-%release
Obsoletes: libgcc = %version, libgcc3.0, libgcc3.1

%description -n libgcc%gcc_branch
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package -n libgcc%gcc_branch-debug
Summary: GNU GCC library with debugging information
Group: System/Libraries
AutoProv: yes, nolib
Requires: libgcc%gcc_branch = %version-%release

%description -n libgcc%gcc_branch-debug
This package contains GCC shared support library with debugging information.
You need this only if you want to step into GCC shared support library
routines during debugging.

####################################################################
# Preprocessor

%package -n cpp%gcc_branch
Summary: The C Preprocessor
Group: Development/C
Provides: cpp = %version-%release, %_bindir/cpp
Obsoletes: gcc-cpp, egcs-cpp, cpp = %version, cpp3.0, cpp3.1
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2

%description -n cpp%gcc_branch
The C preprocessor is a 'macro processor' which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define 'macros,' which are abbreviations for longer
constructs.

The C preprocessor provides four separate facilities that you can use as
you see fit:

* Inclusion of header files. These are files of declarations that can be
  substituted into your program.
* Macro expansion. You can define 'macros,' which are abbreviations for
  arbitrary fragments of C code, and then the C preprocessor will replace
  the macros with their definitions throughout the program.
* Conditional compilation. Using special preprocessing directives,
  you can include or exclude parts of the program according to various
  conditions.
* Line control. If you use a program to combine or rearrange source files
  into an intermediate file which is then compiled, you can use line
  control to inform the compiler about where each source line originated.

You should install this package if you are a programmer who is searching for
such a macro processor.

If you have multiple versions of the GNU Compiler Collection
installed on your system, you will have to type
cpp%psuffix
in order to explicitly use the GNU C Preprocessor version %version.

####################################################################
# C++ Libraries

%package -n libstdc++%gcc_branch
Summary: GNU C++ library
Group: System/Libraries
Provides: libstdc++ = %version-%release
Obsoletes: libstdc++ = %version, libstdc++3.0, libstdc++3.1
Requires: libgcc%gcc_branch = %version-%release

%description -n libstdc++%gcc_branch
The libstdc++ package contains a snapshot of the GCC Standard C++
Library v3, an ongoing project to implement the ISO/IEC 14882:1998
Standard C++ library.

%package -n libstdc++%gcc_branch-devel
Summary: Header files and libraries for C++ development
Group: Development/C++
Provides: libstdc++-devel = %version-%release, %_libdir/libstdc++.so
Obsoletes: libstdc++-devel = %version, libstdc++3.0-devel, libstdc++3.1-devel
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: libstdc++%gcc_branch = %version-%release
Requires: glibc-devel

%description -n libstdc++%gcc_branch-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development.

%package -n libstdc++%gcc_branch-devel-static
Summary: Static libraries for C++ development
Group: Development/C++
Provides: libstdc++-devel-static = %version-%release, %_libdir/libstdc++.a
Obsoletes: libstdc++-devel-static = %version, libstdc++3.0-devel-static, libstdc++3.1-devel-static
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: libstdc++%gcc_branch-devel = %version-%release
Requires: glibc-devel-static

%description -n libstdc++%gcc_branch-devel-static
This is the GNU implementation of the standard C++ libraries.  This
package includes the static libraries needed for C++ development.

%package -n libstdc++%gcc_branch-debug
Summary: GNU C++ library with debugging information
Group: System/Libraries
AutoProv: yes, nolib
Requires: libstdc++%gcc_branch = %version-%release

%description -n libstdc++%gcc_branch-debug
The libstdc++ package contains a snapshot of the GCC Standard C++
Library v3 with debugging information.
You need this only if you want to step into GCC Standard C++ library
routines during debugging.

####################################################################
# C++ Compiler

%package c++
Summary: C++ support for gcc
Group: Development/C++
Provides: gcc-c++ = %version-%release, %_bindir/%_target_platform-g++, %_bindir/g++
Obsoletes: egcs-c++, gcc-c++ = %version, gcc3.0-c++, gcc3.1-c++
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: %name = %version-%release, libstdc++%gcc_branch-devel = %version-%release

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

If you have multiple versions of the GNU Compiler Collection
installed on your system, you will have to type
g++%psuffix
in order to explicitly use the GNU C++ compiler version %version.

####################################################################
# Objective C Libraries

%package -n libobjc%gcc_branch
Summary: Objective C runtime libraries
Group: System/Libraries
Provides: libobjc = %version-%release
Obsoletes: libobjc = %version, libobjc3.0, libobjc3.1
PreReq: gcc-common >= 1.2
Conflicts: libobjc < %version, libobjc > %version

%description -n libobjc%gcc_branch
This package contains Objective C shared library which is needed to run
Objective-C dynamically linked programs.

%package -n libobjc%gcc_branch-devel
Summary: Header files and libraries for Objective C development
Group: Development/Other
Provides: libobjc-devel = %version-%release
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: libobjc%gcc_branch = %version-%release
Requires: glibc-devel

%description -n libobjc%gcc_branch-devel
This is the GNU implementation of the standard Objective C libraries.
This package includes the header files and libraries needed for
Objective C development.

%package -n libobjc%gcc_branch-devel-static
Summary: Static libraries for Objective C development
Group: Development/Other
Provides: libobjc-devel-static = %version-%release
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: libobjc%gcc_branch-devel = %version-%release
Requires: glibc-devel-static

%description -n libobjc%gcc_branch-devel-static
This is the GNU implementation of the standard Objective C libraries.  This
package includes the static libraries needed for Objective C development.

%package -n libobjc%gcc_branch-debug
Summary: Objective C runtime libraries with debugging information
Group: System/Libraries
AutoProv: yes, nolib
Requires: libobjc%gcc_branch = %version-%release

%description -n libobjc%gcc_branch-debug
This package contains Objective C shared library with debugging information.
You need this only if you want to step into GCC Objective C shared library
routines during debugging.

####################################################################
# Objective C Compiler

%package objc
Summary: Objective C support for gcc
Group: Development/Other
Provides: gcc-objc = %version-%release
Obsoletes: gcc-objc = %version, gcc3.0-objc, gcc3.1-objc
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: %name = %version-%release, libobjc%gcc_branch-devel = %version-%release

%description objc
This package provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

####################################################################
# Fortran 77 Library

%package -n libg2c%gcc_branch
Summary: Fortran 77 runtime libraries
Group: System/Libraries
Provides: libg2c = %version-%release, libf2c = %version-%release
Obsoletes: libf2c, libf2c3.0, libf2c3.1, libf2c3.2

%description -n libg2c%gcc_branch
This package contains Fortran 77 shared library which is needed to run
Fortran 77 dynamically linked programs.

%package -n libg2c%gcc_branch-devel
Summary: Header files and libraries for Fortran 77 development
Group: Development/Other
Provides: libg2c-devel = %version-%release
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: libg2c%gcc_branch = %version-%release
Requires: glibc-devel

%description -n libg2c%gcc_branch-devel
This is the GNU implementation of the standard Fortran 77 libraries.
This package includes the header files and libraries needed for
Fortran 77 development.

%package -n libg2c%gcc_branch-devel-static
Summary: Static libraries for Fortran 77 development
Group: Development/Other
Provides: libg2c-devel-static = %version-%release
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: libg2c%gcc_branch-devel = %version-%release
Requires: glibc-devel-static

%description -n libg2c%gcc_branch-devel-static
This is the GNU implementation of the standard Fortran 77 libraries.  This
package includes the static libraries needed for Fortran 77 development.

%package -n libg2c%gcc_branch-debug
Summary: Fortran 77 runtime libraries with debugging information.
Group: System/Libraries
AutoProv: yes, nolib
Requires: libg2c%gcc_branch = %version-%release

%description -n libg2c%gcc_branch-debug
This package contains Fortran 77 shared library with debugging information.
You need this only if you want to step into GCC Fortran 77 shared library
routines during debugging.

####################################################################
# Fortran 77 Compiler

%package g77
Summary: Fortran 77 support for gcc
Group: Development/Other
Provides: gcc-g77 = %version-%release, %_bindir/%_target_platform-g77, %_bindir/g77
Obsoletes: gcc-g77 = %version, gcc3.0-g77, gcc3.1-g77
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: %name = %version-%release, libg2c%gcc_branch-devel = %version-%release

%description g77
This package provides support for compiling Fortran 77
programs with the GNU Compiler Collection.

If you have multiple versions of the GNU Compiler Collection
installed on your system, you will have to type
g77%psuffix
in order to explicitly use the GNU Fortran 77 compiler version %version.

####################################################################
# Java Libraries

%package -n libgcj%gcc_branch
Summary: GNU Java runtime libraries
Group: System/Libraries
Provides: libgcj = %version-%release
Obsoletes: libgcj = %version, libgcj3.0, libgcj3.1
Requires: zip >= 2.1

%description -n libgcj%gcc_branch
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj%gcc_branch-devel
Summary: Header files and libraries for Java development
Group: Development/Java
Provides: libgcj-devel = %version-%release
Obsoletes: libgcj-devel = %version, libgcj3.0-devel, libgcj3.1-devel
Requires: libgcj%gcc_branch = %version-%release, zlib-devel
Requires: glibc-devel

%description -n libgcj%gcc_branch-devel
The Java(tm) development libraries and include files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).

%package -n libgcj%gcc_branch-devel-static
Summary: Static libraries for Java development
Group: Development/Java
Provides: libgcj-devel-static = %version-%release
Obsoletes: libgcj-devel-static = %version, libgcj3.0-devel-static, libgcj3.1-devel-static
Requires: libgcj%gcc_branch-devel = %version-%release
Requires: glibc-devel-static

%description -n libgcj%gcc_branch-devel-static
The Java(tm) static libraries. You may need this
package to compile your Java programs using the GCC Java compiler (gcj).

%package -n libgcj%gcc_branch-debug
Summary: GNU Java runtime libraries with debugging information
Group: System/Libraries
AutoProv: yes, nolib
Requires: libgcj%gcc_branch = %version-%release

%description -n libgcj%gcc_branch-debug
The Java(tm) runtime library with debugging information.
You need this only if you want to step into GCC Java(tm) runtime library
routines during debugging.

####################################################################
# Java Compiler

%package java
Summary: Java support for gcc
Group: Development/Java
Provides: gcc-java = %version-%release, %_bindir/gcj
Obsoletes: gcc3.0-java, gcc3.1-java, gcj3.1-tools, gcj%gcc_branch-tools, gcc-java = %version
PreReq: /usr/sbin/update-alternatives, gcc-common >= 1.2
Requires: %name = %version-%release, libgcj%gcc_branch-devel = %version-%release
Conflicts: kaffe < 1.0.7

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

If you have multiple versions of the GNU Compiler Collection
installed on your system, you will have to type
gcj%psuffix
in order to explicitly use the GNU Java compiler version %version.

####################################################################
# GCC documentation

%package doc
Summary: GCC documentation
Group: Development/Other
Provides: gcc-doc = %version-%release
Obsoletes: gcc-doc = %version, gcc3.0-doc, gcc3.1-doc
Requires(pre,postun): %__install_info
Conflicts: gcc-doc < %version, gcc-doc > %version

%description doc
This package contains documentation for the GNU Compiler Collection
version %version.

%prep
%setup -q -n %srcdirname
find -type d -name CVS -print0 |
	xargs -r0 rm -rf --

# RH patches
%patch1 -p0 -b .2.96-RH-compat~
%patch2 -p0 -b .boehm-gc-libs~
%patch3 -p0 -b .bogus-inline~
%patch6 -p0 -b .fde-merge-compat~
%patch7 -p0 -b .attr-visibility~
%patch8 -p0 -b .attr-visibility2~
%patch9 -p0 -b .duplicate-decl~
#%patch10 -p0 -b .trunc_int_for_mode~
%patch11 -p0 -b .sparc-sll1~
#%patch12 -p0 -b .x86_64-q_regs_operand~
%patch13 -p0 -b .dwarf2-pr6381~
%patch14 -p0 -b .dwarf2-pr6436-test~
%patch15 -p0 -b .c++-pretty_function~
%patch16 -p0 -b .c++-tsubst-asm~
%patch18 -p0 -b .i386-memtest-test~
#%patch19 -p0 -b .fold-const2~
%patch21 -p0 -b .ada-addr2line~
%patch22 -p0 -b .ada-link~
%patch23 -p0 -b .java-no-rpath~
%patch25 -p0 -b .s390-java~
%patch26 -p0 -b .test-rotate~
%patch27 -p0 -b .x86_64-libiberty-pic~
%patch29 -p0 -b .test-rh65771~
%patch30 -p0 -b .i386-default-momit-leaf-frame-pointer~
%patch31 -p0 -b .i386-pic-label-thunk~
%patch34 -p0 -b .pr6842~
%patch35 -p0 -b .tls~
%patch36 -p0 -b .i386-profile-olfp~
%patch37 -p0 -b .tree-code~
%patch38 -p0 -b .hard-reg-sharing~
%patch39 -p0 -b .hard-reg-sharing2~
%patch40 -p0 -b .c++-nrv-test~
%patch41 -p0 -b .debug-pr7241~
#%patch42 -p0 -b .i386-pr7242~
%patch43 -p0 -b .cfg-eh~
%patch44 -p0 -b .attr-visibility3~
%patch45 -p0 -b .tls2~
%patch46 -p0 -b .fold-const-associate~
%patch47 -p0 -b .inline-label~
%patch48 -p0 -b .typeof-asm~
#%patch50 -p0 -b .rh69989~
%patch54 -p0 -b .tls5~
%patch55 -p0 -b .tls-dwarf2~
%patch56 -p0 -b .x86_64-pr7559~
#%patch57 -p0 -b .loop-prefetch~
%patch58 -p0 -b .doc-gcov~
%patch59 -p0 -b .attr-visibility4~
#%patch60 -p0 -b .c++-tail-pad-backout~
%patch61 -p0 -b .attr-visibility5~
%patch62 -p0 -b .i386-no-default-momit-leaf-frame-pointer~
%patch64 -p0 -b .x86_64-rip-lowercase~
#%patch65 -p0 -b .libstdc++-glibc23-1~
#%patch66 -p0 -b .libstdc++-glibc23-2~
#%patch67 -p0 -b .libstdc++-glibc23-3~
#%patch68 -p0 -b .libstdc++-glibc23-4~
#%patch69 -p0 -b .interface_only

# SuSE patches
%patch501 -p1 -b .DESTDIR

# MDK patches
%patch601 -p1 -b .strip-dotdot

# ALT patches
%patch701 -p0
%patch702 -p1
%patch703 -p1

(cd gcc && autoconf_2.13)

# Set proper version & contact info.
%__subst 's,#define GCCBUGURL.*$,#define GCCBUGURL "<URL:http://bugs.altlinux.ru/>",' gcc/system.h
%__subst 's/\(%gcc_branch\(\.[0-9]\+\)*\)\( [0-9]\+[a-z]*\)\?.*"/\1\3 (%os_release)"/' gcc/version.c gcc/f/version.c gcc/ada/gnatvsn.ads

./contrib/gcc_update --touch

%build
%define buildtarget build-%_target_platform
rm -rf %buildtarget
mkdir %buildtarget
pushd %buildtarget

CC=gcc
%remove_optflags %optflags_nocpp %optflags_notraceback

CC="$CC" \
CFLAGS="$RPM_OPT_FLAGS" \
CXXFLAGS="$RPM_OPT_FLAGS" \
GCJFLAGS="$RPM_OPT_FLAGS" \
XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" \
	../configure --prefix=%prefix \
	--libdir=%_libdir \
	--with-slibdir=/lib \
	--mandir=%_mandir \
	--infodir=%_infodir \
	--enable-shared \
	--enable-threads=posix \
	--disable-checking \
	--enable-long-long \
	--enable-__cxa_atexit \
	--enable-languages="c,c++%{?_with_fortran:,f77}%{?_with_objc:,objc}%{?_with_java:,java}" \
	--program-suffix=%psuffix \
	--enable-objc-gc \
	--with-system-zlib \
	--without-included-gettext \
	--host=%_target_platform --build=%_target_platform --target=%_target_platform

touch ../gcc/c-gperf.h

%make_build bootstrap-lean

%if_with testsuite
make -k check
../contrib/test_summary
%endif #with_testsuite

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

popd #%buildtarget

# build printable documentation
%if_with pdf
(cd gcc/doc; for f in gcc cpp cppinternals; do
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include $f.texi
done)
%if_with fortran
(cd gcc/f; for f in g77
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include $f.texi
)
%endif #with_fortran
%if_with java
(cd gcc/java; for f in gcj
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include $f.texi
)
%endif #with_java
%endif #with_pdf

%install
%__mkdir_p $RPM_BUILD_ROOT%gcc_doc_dir

# Copy various doc files here and there
CopyDocs()
{
	local n="$1"
	shift
	%__mkdir_p "$RPM_BUILD_ROOT%gcc_doc_dir/$n"
	local d="$1"
	shift
	local f
	for f in "$d"/*{README,NEWS,ChangeLog,LICENSE,THREADS}*; do
		[ -f "$f" ] || continue
		%__install -pv -m644 "$f" "$RPM_BUILD_ROOT%gcc_doc_dir/$n/"
	done
}

CopyDocs gcc gcc
CopyDocs g++ gcc/cp
CopyDocs libstdc++ libstdc++-v3
%__cp -av libstdc++-v3/docs/html $RPM_BUILD_ROOT%gcc_doc_dir/libstdc++/

%if_with fortran
CopyDocs g77 gcc/f
CopyDocs libg2c libf2c
%endif #with_fortran

%if_with objc
CopyDocs objc gcc/objc
CopyDocs libobjc libobjc
%endif #with_objc

%if_with java
CopyDocs boehm-gc boehm-gc
%__install -pv -m644 boehm-gc/doc/* $RPM_BUILD_ROOT%gcc_doc_dir/boehm-gc/
CopyDocs java gcc/java
CopyDocs fastjar fastjar
CopyDocs libffi libffi
CopyDocs libjava libjava
%endif #with_java

# Fix HTML docs for libstdc++-v3.
%__perl -pi -e 's,href="l(ibstdc|atest),href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1,' \
	$RPM_BUILD_ROOT%gcc_doc_dir/libstdc++/html/documentation.html
%__ln_s documentation.html $RPM_BUILD_ROOT%gcc_doc_dir/libstdc++/html/index.html

# Compress changelogs.
find $RPM_BUILD_ROOT%gcc_doc_dir -type f -name *ChangeLog\* \! -name \*.bz2 -print0 |
	xargs -r0 bzip2 -9 --

pushd %buildtarget

%makeinstall slibdir=$RPM_BUILD_ROOT/lib -o install-target-libstdc++-v3 -o install-target-libjava
LD_LIBRARY_PATH=$RPM_BUILD_ROOT%_libdir \
	make install-target-libstdc++-v3 DESTDIR=$RPM_BUILD_ROOT
%if_with java
	make install-target-libjava DESTDIR=$RPM_BUILD_ROOT
%endif #with_java
popd #%buildtarget

%__rm -f $RPM_BUILD_ROOT%_bindir/addr2name.awk*

# Rename binaries which will be packaged under alternatives control.
pushd $RPM_BUILD_ROOT%_bindir
	for n in \
	  cpp \
	  gcc gcov protoize unprotoize \
	  g++ c++filt \
	  g77 \
	  %{?_with_java:gcj gcjh gij jcf-dump jv-scan grepjar jar rmic rmiregistry} \
	  ; do
		[ ! -f "%_target_platform-$n%psuffix" ] || continue
		%__mv -v "$n%psuffix" "%_target_platform-$n%psuffix"
		%__ln_s "%_target_platform-$n%psuffix" "$n%psuffix"
	done
popd

# Relocate libraries to the right directories.
pushd $RPM_BUILD_ROOT%_libdir
	%__rm -f libiberty.a
	%__mv *.*a $RPM_BUILD_ROOT%gcc_target_dir/
	for f in *.so; do
		v=`readlink "$f"`
		[ -f "$v" ]
		%__ln_s ../../../"$v" "$RPM_BUILD_ROOT%gcc_target_dir/$f"
		%__rm -f "$f"
	done
popd
pushd $RPM_BUILD_ROOT
	chmod 755 lib/libgcc_s.so.*
	f=`readlink lib/libgcc_s.so`
	[ -f lib/"$f" ]
	%__ln_s ../../lib/"$f" .%_libdir/libgcc_s.so
	%__rm -f lib/libgcc_s.so
popd

# Normalize manpage names.
pushd $RPM_BUILD_ROOT%_man1dir
	for f in cpp gcov gij; do
		%__mv "$f".1 "$f"%psuffix.1
	done
	%__rm -fv g++%psuffix.1
popd

%if_with java
# Relocate Java headers to version-specific compiler directory.
%__mv $RPM_BUILD_ROOT%_includedir/{gc,j}*.h $RPM_BUILD_ROOT%gcc_target_dir/include/
%__mv $RPM_BUILD_ROOT%_includedir/{java,javax,gnu,org} $RPM_BUILD_ROOT%gcc_target_dir/include/
%__mkdir_p $RPM_BUILD_ROOT%gcc_target_dir/include/gcj
%__mv $RPM_BUILD_ROOT%_includedir/gcj/* $RPM_BUILD_ROOT%gcc_target_dir/include/gcj/
rmdir $RPM_BUILD_ROOT%_includedir/gcj

# Move libgcj.spec to compiler-specific directory.
%__sed -e 's/-lgcjgc//g;s/-lzgcj//g;s/-lpthread//g' $RPM_BUILD_ROOT%_libdir/libgcj.spec \
	>$RPM_BUILD_ROOT%gcc_target_dir/libgcj.spec
%endif #with_java

# Correct permissions if required.
chmod 755 $RPM_BUILD_ROOT%_libdir/lib*.so*

# buildreq substitution rules.
%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
for n in cpp gcc gcc-c++ gcc-g77 gcc-java gcc-objc libg2c libg2c-devel libg2c-devel-static libgcc libgcj libgcj-devel libgcj-devel-static libobjc libobjc-devel libobjc-devel-static libstdc++ libstdc++-devel libstdc++-devel-static; do
	pref="${n%%%%-*}"
	suf="${n#$pref}"
	t="${pref}%gcc_branch$suf"
	echo "$n" >"$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/$t"
done
chmod 644 $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/*

# buildreq ignore rules.
%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/files/ignore.d
cat >$RPM_BUILD_ROOT%_sysconfdir/buildreqs/files/ignore.d/%name <<EOF
^%gcc_target_dir(/include)?$
EOF

%find_lang gcc

%__mkdir_p $RPM_BUILD_ROOT%_libdir/debug
%__cp -a $RPM_BUILD_ROOT{/lib,%_libdir}/*.so.* $RPM_BUILD_ROOT%_libdir/debug/

%if_enabled debug
# Don't strip in debug mode
%set_strip_method none
%endif #enabled_debug

%set_compress_method bzip2

%post -n cpp%gcc_branch
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-cpp %_target_platform-cpp %_bindir/%_target_platform-cpp%psuffix %priority \
	--slave %_man1dir/cpp.1.bz2 cpp.1.bz2 %_man1dir/cpp%psuffix.1.bz2

%triggerpostun -n cpp%gcc_branch -- cpp, cpp2.96
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-cpp %_target_platform-cpp %_bindir/%_target_platform-cpp%psuffix %priority \
	--slave %_man1dir/cpp.1.bz2 cpp.1.bz2 %_man1dir/cpp%psuffix.1.bz2

%preun -n cpp%gcc_branch
[ $1 = 0 ] || exit 0
/usr/sbin/update-alternatives --remove %_target_platform-cpp %_bindir/%_target_platform-cpp%psuffix

%triggerun -n cpp%gcc_branch -- cpp3.2 < 0:3.2.1-alt1
[ $2 != 0 ] || exit 0
/usr/sbin/update-alternatives --remove cpp %_bindir/cpp%psuffix

%post
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-gcc %_target_platform-gcc %_bindir/%_target_platform-gcc%psuffix %priority \
	--slave %_bindir/%_target_platform-gcov %_target_platform-gcov %_bindir/%_target_platform-gcov%psuffix \
	--slave %_bindir/%_target_platform-protoize %_target_platform-protoize %_bindir/%_target_platform-protoize%psuffix \
	--slave %_bindir/%_target_platform-unprotoize %_target_platform-unprotoize %_bindir/%_target_platform-unprotoize%psuffix \
	--slave %_man1dir/gcc.1.bz2 gcc.1.bz2 %_man1dir/gcc%psuffix.1.bz2 \
	--slave %_man1dir/gcov.1.bz2 gcov.1.bz2 %_man1dir/gcov%psuffix.1.bz2

%triggerpostun -- gcc, gcc2.96
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-gcc %_target_platform-gcc %_bindir/%_target_platform-gcc%psuffix %priority \
	--slave %_bindir/%_target_platform-gcov %_target_platform-gcov %_bindir/%_target_platform-gcov%psuffix \
	--slave %_bindir/%_target_platform-protoize %_target_platform-protoize %_bindir/%_target_platform-protoize%psuffix \
	--slave %_bindir/%_target_platform-unprotoize %_target_platform-unprotoize %_bindir/%_target_platform-unprotoize%psuffix \
	--slave %_man1dir/gcc.1.bz2 gcc.1.bz2 %_man1dir/gcc%psuffix.1.bz2 \
	--slave %_man1dir/gcov.1.bz2 gcov.1.bz2 %_man1dir/gcov%psuffix.1.bz2

%preun
[ $1 = 0 ] || exit 0
/usr/sbin/update-alternatives --remove %_target_platform-gcc %_bindir/%_target_platform-gcc%psuffix

%triggerun -- gcc3.2 < 0:3.2.1-alt1
[ $2 != 0 ] || exit 0
/usr/sbin/update-alternatives --remove gcc %_bindir/gcc%psuffix
/usr/sbin/update-alternatives --remove %_target_platform-gcc %_bindir/gcc%psuffix


%post c++
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-g++ %_target_platform-g++ %_bindir/%_target_platform-g++%psuffix %priority \
	--slave %_bindir/%_target_platform-c++filt %_target_platform-c++filt %_bindir/%_target_platform-c++filt%psuffix \
	--slave %_man1dir/g++.1.bz2 g++.1.bz2 %_man1dir/gcc%psuffix.1.bz2

%triggerpostun c++ -- gcc-c++, gcc2.96-c++
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-g++ %_target_platform-g++ %_bindir/%_target_platform-g++%psuffix %priority \
	--slave %_bindir/%_target_platform-c++filt %_target_platform-c++filt %_bindir/%_target_platform-c++filt%psuffix \
	--slave %_man1dir/g++.1.bz2 g++.1.bz2 %_man1dir/gcc%psuffix.1.bz2

%preun c++
[ $1 = 0 ] || exit 0
/usr/sbin/update-alternatives --remove %_target_platform-g++ %_bindir/%_target_platform-g++%psuffix

%triggerun c++ -- gcc3.2-c++ < 0:3.2.1-alt1
[ $2 != 0 ] || exit 0
/usr/sbin/update-alternatives --remove g++ %_bindir/g++%psuffix
/usr/sbin/update-alternatives --remove %_target_platform-g++ %_bindir/g++%psuffix


%post g77
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-g77 %_target_platform-g77 %_bindir/%_target_platform-g77%psuffix %priority \
	--slave %_man1dir/g77.1.bz2 g77.1.bz2 %_man1dir/g77%psuffix.1.bz2

%triggerpostun g77 -- gcc-g77, gcc2.96-g77
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-g77 %_target_platform-g77 %_bindir/%_target_platform-g77%psuffix %priority \
	--slave %_man1dir/g77.1.bz2 g77.1.bz2 %_man1dir/g77%psuffix.1.bz2

%preun g77
[ $1 = 0 ] || exit 0
/usr/sbin/update-alternatives --remove %_target_platform-g77 %_bindir/%_target_platform-g77%psuffix

%triggerun g77 -- gcc3.2-g77 < 0:3.2.1-alt1
[ $2 != 0 ] || exit 0
/usr/sbin/update-alternatives --remove g77 %_bindir/g77%psuffix
/usr/sbin/update-alternatives --remove %_target_platform-g77 %_bindir/g77%psuffix


%post java
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-gcj %_target_platform-gcj %_bindir/%_target_platform-gcj%psuffix %priority \
	--slave %_bindir/%_target_platform-gcjh %_target_platform-gcjh %_bindir/%_target_platform-gcjh%psuffix \
	--slave %_bindir/%_target_platform-gij %_target_platform-gij %_bindir/%_target_platform-gij%psuffix \
	--slave %_bindir/%_target_platform-jcf-dump %_target_platform-jcf-dump %_bindir/%_target_platform-jcf-dump%psuffix \
	--slave %_bindir/%_target_platform-jv-scan %_target_platform-jv-scan %_bindir/%_target_platform-jv-scan%psuffix \
	--slave %_bindir/%_target_platform-grepjar %_target_platform-grepjar %_bindir/%_target_platform-grepjar%psuffix \
	--slave %_bindir/%_target_platform-jar %_target_platform-jar %_bindir/%_target_platform-jar%psuffix \
	--slave %_bindir/%_target_platform-rmic %_target_platform-rmic %_bindir/%_target_platform-rmic%psuffix \
	--slave %_bindir/%_target_platform-rmiregistry %_target_platform-rmiregistry %_bindir/%_target_platform-rmiregistry%psuffix \
	--slave %_man1dir/gcj.1.bz2 gcj.1.bz2 %_man1dir/gcj%psuffix.1.bz2 \
	--slave %_man1dir/gij.1.bz2 gij.1.bz2 %_man1dir/gij%psuffix.1.bz2

%triggerpostun java -- gcc-java, gcc2.96-java
/usr/sbin/update-alternatives \
	--install %_bindir/%_target_platform-gcj %_target_platform-gcj %_bindir/%_target_platform-gcj%psuffix %priority \
	--slave %_bindir/%_target_platform-gcjh %_target_platform-gcjh %_bindir/%_target_platform-gcjh%psuffix \
	--slave %_bindir/%_target_platform-gij %_target_platform-gij %_bindir/%_target_platform-gij%psuffix \
	--slave %_bindir/%_target_platform-jcf-dump %_target_platform-jcf-dump %_bindir/%_target_platform-jcf-dump%psuffix \
	--slave %_bindir/%_target_platform-jv-scan %_target_platform-jv-scan %_bindir/%_target_platform-jv-scan%psuffix \
	--slave %_bindir/%_target_platform-grepjar %_target_platform-grepjar %_bindir/%_target_platform-grepjar%psuffix \
	--slave %_bindir/%_target_platform-jar %_target_platform-jar %_bindir/%_target_platform-jar%psuffix \
	--slave %_bindir/%_target_platform-rmic %_target_platform-rmic %_bindir/%_target_platform-rmic%psuffix \
	--slave %_bindir/%_target_platform-rmiregistry %_target_platform-rmiregistry %_bindir/%_target_platform-rmiregistry%psuffix \
	--slave %_man1dir/gcj.1.bz2 gcj.1.bz2 %_man1dir/gcj%psuffix.1.bz2 \
	--slave %_man1dir/gij.1.bz2 gij.1.bz2 %_man1dir/gij%psuffix.1.bz2

%preun java
[ $1 = 0 ] || exit 0
/usr/sbin/update-alternatives --remove %_target_platform-gcj %_bindir/%_target_platform-gcj%psuffix

%triggerun java -- gcc3.2-java < 0:3.2.1-alt1
[ $2 != 0 ] || exit 0
/usr/sbin/update-alternatives --remove gcj %_bindir/gcj%psuffix
/usr/sbin/update-alternatives --remove %_target_platform-gcj %_bindir/gcj%psuffix


%post -n libgcc%gcc_branch -p %post_ldconfig
%postun -n libgcc%gcc_branch -p %postun_ldconfig

%post -n libstdc++%gcc_branch -p %post_ldconfig
%postun -n libstdc++%gcc_branch -p %postun_ldconfig

%post -n libg2c%gcc_branch -p %post_ldconfig
%postun -n libg2c%gcc_branch -p %postun_ldconfig

%post -n libobjc%gcc_branch -p %post_ldconfig
%postun -n libobjc%gcc_branch -p %postun_ldconfig

%post -n libgcj%gcc_branch -p %post_ldconfig
%postun -n libgcj%gcc_branch -p %postun_ldconfig

%post doc
%install_info {cpp,cppinternals,gcc,gccint%{?_with_fortran:,g77}%{?_with_java:,gcj}}.info

%preun doc
%uninstall_info {cpp,cppinternals,gcc,gccint%{?_with_fortran:,g77}%{?_with_java:,gcj}}.info

%files -f gcc.lang
%config %_sysconfdir/buildreqs/packages/substitute.d/%name
%config %_sysconfdir/buildreqs/files/ignore.d/%name
%dir %gcc_doc_dir
%gcc_doc_dir/gcc
%_libdir/libgcc_s.so
%_bindir/gcc%psuffix
%_bindir/gcov%psuffix
%_bindir/protoize%psuffix
%_bindir/unprotoize%psuffix
%_bindir/%_target_platform-gcc%psuffix
%_bindir/%_target_platform-gcov%psuffix
%_bindir/%_target_platform-protoize%psuffix
%_bindir/%_target_platform-unprotoize%psuffix
%_man1dir/gcc%psuffix.*
%_man1dir/gcov%psuffix.*
%dir %gcc_target_dir
%gcc_target_dir/cc1
%gcc_target_dir/collect2
%gcc_target_dir/crt*.o
%gcc_target_dir/libgcc.a
%gcc_target_dir/libgcc_eh.a
%gcc_target_dir/SYSCALLS.c.X
%gcc_target_dir/specs
%dir %gcc_target_dir/include
%gcc_target_dir/include/float.h
%gcc_target_dir/include/*mmintrin.h
%gcc_target_dir/include/iso646.h
%gcc_target_dir/include/limits.h
%gcc_target_dir/include/stdarg.h
%gcc_target_dir/include/stdbool.h
%gcc_target_dir/include/stddef.h
%gcc_target_dir/include/stdio.h
%gcc_target_dir/include/syslimits.h
%gcc_target_dir/include/varargs.h
%gcc_target_dir/include/README

%files -n libgcc%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libgcc%gcc_branch
/%_lib/libgcc_s.so.*

%files -n libgcc%gcc_branch-debug
%_libdir/debug/libgcc_s.so.*

%files -n cpp%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/cpp%gcc_branch
%_bindir/cpp%psuffix
%_bindir/%_target_platform-cpp%psuffix
%_man1dir/cpp%psuffix.*
%dir %gcc_target_dir
%gcc_target_dir/cpp0
%gcc_target_dir/tradcpp0

%files -n libstdc++%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libstdc++%gcc_branch
%_libdir/libstdc++.so.*

%files -n libstdc++%gcc_branch-devel
%config %_sysconfdir/buildreqs/packages/substitute.d/libstdc++%gcc_branch-devel
%dir %gcc_doc_dir
%gcc_doc_dir/libstdc++
%_includedir/c++/*
%dir %gcc_target_dir
%gcc_target_dir/libstdc++.so
#%_libdir/libstdc++.la
%gcc_target_dir/libsupc++.a
#%_libdir/libsupc++.la

%files -n libstdc++%gcc_branch-devel-static
%config %_sysconfdir/buildreqs/packages/substitute.d/libstdc++%gcc_branch-devel-static
%dir %gcc_target_dir
%gcc_target_dir/libstdc++.a

%files -n libstdc++%gcc_branch-debug
%_libdir/debug/libstdc++.so.*

%files c++
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-c++
%dir %gcc_doc_dir
%gcc_doc_dir/g++
%_bindir/g++%psuffix
%_bindir/c++filt%psuffix
%_bindir/%_target_platform-g++%psuffix
%_bindir/%_target_platform-c++filt%psuffix
%dir %gcc_target_dir
%gcc_target_dir/cc1plus

%if_with objc
%files -n libobjc%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libobjc%gcc_branch
%_libdir/libobjc*.so.*

%files -n libobjc%gcc_branch-devel
%config %_sysconfdir/buildreqs/packages/substitute.d/libobjc%gcc_branch-devel
%dir %gcc_doc_dir
%gcc_doc_dir/libobjc
%dir %gcc_target_dir
%gcc_target_dir/libobjc*.so
#%_libdir/libobjc*.la
%dir %gcc_target_dir/include
%gcc_target_dir/include/objc

%files -n libobjc%gcc_branch-devel-static
%config %_sysconfdir/buildreqs/packages/substitute.d/libobjc%gcc_branch-devel-static
%dir %gcc_target_dir
%gcc_target_dir/libobjc*.a

%files -n libobjc%gcc_branch-debug
%_libdir/debug/libobjc*.so.*

%files objc
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-objc
%dir %gcc_doc_dir
%gcc_doc_dir/objc
%dir %gcc_target_dir
%gcc_target_dir/cc1obj
%endif #with_objc

%if_with fortran
%files -n libg2c%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libg2c%gcc_branch
%_libdir/libg2c.so.*

%files -n libg2c%gcc_branch-devel
%config %_sysconfdir/buildreqs/packages/substitute.d/libg2c%gcc_branch-devel
%dir %gcc_doc_dir
%gcc_doc_dir/libg2c
%dir %gcc_target_dir
%gcc_target_dir/libg2c.so
#%_libdir/libg2c.la
%dir %gcc_target_dir/include
%gcc_target_dir/include/g2c.h

%files -n libg2c%gcc_branch-devel-static
%config %_sysconfdir/buildreqs/packages/substitute.d/libg2c%gcc_branch-devel-static
%dir %gcc_target_dir
%gcc_target_dir/libg2c.a

%files -n libg2c%gcc_branch-debug
%_libdir/debug/libg2c.so.*

%files g77
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-g77
%dir %gcc_doc_dir
%gcc_doc_dir/g77
%_bindir/g77%psuffix
%_bindir/%_target_platform-g77%psuffix
%_man1dir/g77%psuffix.*
%dir %gcc_target_dir
%gcc_target_dir/f771
%gcc_target_dir/libfrtbegin.a
%endif #with_fortran

%if_with java
%files -n libgcj%gcc_branch
%config %_sysconfdir/buildreqs/packages/substitute.d/libgcj%gcc_branch
%_libdir/libgcj.so.*
%_libdir/security/*
%_datadir/java/*

%files -n libgcj%gcc_branch-devel
%config %_sysconfdir/buildreqs/packages/substitute.d/libgcj%gcc_branch-devel
%dir %gcc_doc_dir
%gcc_doc_dir/boehm-gc
%gcc_doc_dir/libffi
%gcc_doc_dir/libjava
%_bindir/jv-convert%psuffix
%_man1dir/jv-convert.*
%dir %gcc_target_dir
%gcc_target_dir/libgcj.spec
%gcc_target_dir/libgcj.so
#%_libdir/libgcj.la
%dir %gcc_target_dir/include
%gcc_target_dir/include/gc*.h
%gcc_target_dir/include/j*.h
%gcc_target_dir/include/java
%gcc_target_dir/include/javax
%gcc_target_dir/include/gnu
%gcc_target_dir/include/gcj
%gcc_target_dir/include/org

%files -n libgcj%gcc_branch-devel-static
%config %_sysconfdir/buildreqs/packages/substitute.d/libgcj%gcc_branch-devel-static
%dir %gcc_target_dir
%gcc_target_dir/libgcj.a

%files -n libgcj%gcc_branch-debug
%_libdir/debug/libgcj.so.*

%files java
%config %_sysconfdir/buildreqs/packages/substitute.d/%name-java
%dir %gcc_doc_dir
%gcc_doc_dir/fastjar
%gcc_doc_dir/java
%_bindir/gcj*%psuffix
%_bindir/%_target_platform-gcj*%psuffix
%_bindir/gij%psuffix
%_bindir/%_target_platform-gij%psuffix
%_bindir/jcf-dump%psuffix
%_bindir/%_target_platform-jcf-dump%psuffix
%_bindir/jv-scan%psuffix
%_bindir/%_target_platform-jv-scan%psuffix
%_bindir/*jar%psuffix
%_bindir/rmi*%psuffix
%_bindir/%_target_platform-rmi*%psuffix
%_man1dir/gij*.*
%_man1dir/gcj*.*
%_man1dir/jv-scan.*
%_man1dir/jcf-dump.*
%_man1dir/rmi*.*
%dir %gcc_target_dir
%gcc_target_dir/jc1
%gcc_target_dir/jvgenmain
%endif #with_java

%files doc
%_infodir/cpp*.info*
%_infodir/gcc*.info*
%{?_with_fortran:%_infodir/g77.info*}
%{?_with_java:%_infodir/gcj.info*}
%if_with pdf
%doc gcc/doc/cpp*.pdf
%doc gcc/doc/gcc*.pdf
%{?_with_fortran:%doc gcc/doc/g77.pdf}
%endif #with_pdf

%changelog
* Fri Nov 29 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2.1-alt2
- Fixed typo in "%%triggerpostun c++".

* Tue Nov 26 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2.1-alt1
- Updated to 3.2.1 release (3.2.1 20021119).
- Following patches merged upstream:
  + trunc_int_for_mode;
  + x86_64-q_regs_operand;
  + fold-const2;
  + i386-pr7242;
  + i386-pr7242;
  + loop-prefetch;
  + libstdc++-glibc23-1;
  + libstdc++-glibc23-2;
  + libstdc++-glibc23-3;
  + libstdc++-glibc23-4;
  + interface_only.
- Updated patches: tls, doc-gcov.
- Dropped patches: c++-tail-pad-backout.
- Added missing provides to gcc subpackage.
- Removed soname provides from -debug subpackages.
- Removed %_libdir/libstdc++.{so,a} (no longer needed).
- Moved java wrappers to separate subpackage (jdkgcj).
- Moved gccbug to separate subpackage (gcc-common).
- Removed prefixes from: jar grepjar rmic rmiregistry.
- Migrated to new alternatives scheme.

* Mon Sep 30 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2.1-alt0.4
- Merged with rh gcc-3.2-7:
  * Tue Sep  3 2002 Bill Nottingham <notting@redhat.com> 3.2-7
  - fix calling of C++ destructors in certain cases
  * Tue Sep  3 2002 Jakub Jelinek <jakub@redhat.com> 3.2-6
  - update from CVS (but revert C++ tail padding patches
    for now)
  - further fixes to make libstdc++-v3 build on glibc 2.3
  - run libstdc++-v3 make check-abi on IA-32 during testing
  * Fri Aug 30 2002 Jakub Jelinek <jakub@redhat.com> 3.2-5
  - disable tail copy patches, they seem to still have problems
  - make libstdc++-v3 build on glibc 2.3 (and use thread-local
    locale model)
- libstdc++%gcc_branch:
  Added explicit versioned dependence on libgcc%gcc_branch (#0001332).
- %name-java: fixed update-alternatives.

* Fri Sep 06 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2.1-alt0.3
- Disabled c++-tail-pad patch (causes internal errors in cpp code).
- Switched back to default stripping policy:
  make use of new (rpm-build >= 4.0.4-alt3) strip feature.
- Moved unstripped shared libraries to -debug subpackages.

* Fri Aug 30 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2.1-alt0.2
- Merged with rh gcc-3.2-4:
  * Wed Aug 26 2002 Jakub Jelinek <jakub@redhat.com> 3.2-4
  - reorder alpha_encode_section_info checks slightly to fix an ICE
    when building glibc and to take better advantage of visibility
    attribute on Alpha
  - as gdb is not there yet, disable -momit-leaf-frame-pointer
    by default for now on IA-32
  - fix IA-64 bootstrap with tail padding patch (Jason Merrill, Daniel Berlin)
  - fix x86-64 %RIP to %rip, only output (%rip) if no other relocation
    is used (Richard Henderson)
  * Fri Aug 23 2002 Jakub Jelinek <jakub@redhat.com> 3.2-3
  - take advantage of __attribute__((visibility())) on Alpha
  - avoid copying tail padding (Jason Merrill)
- Use /bin/readlink.
- Added "Conflicts: glibc-devel < 2.2.6".
- Raised alternatives priority from 15 to 30.

* Mon Aug 26 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2.1-alt0.1
- Updated to snapshot 20020822.
- Merged ALT patches from 2.96 branch.
- Merged with rh gcc-3.2-2:
  * Thu Aug 22 2002 Jakub Jelinek <jakub@redhat.com> 3.2-2
  - fixed Dwarf2 DW_OP_GNU_push_tls_address patch from Richard Henderson.
  - don't mention removed -a and -ax options in the documentation
    (Nathan Sidwell, #72233).
  - fixed __typeof() followed by __asm() redirection from Alexandre Oliva.

* Wed Aug 21 2002 Dmitry V. Levin <ldv@altlinux.org> 3.2-alt3
- Rewritten interpackage dependencies to make peace with other
  versions of GCC which may be installed in the system.
- Dropped gnat.
- Added %%with/%%without logic for conditional build.
- Cleaned up descriptions.
- Cleaned up %%prep and %%build sections.
- Rewritten %%install section (no idea how it could work before).
- Set proper version information.
- Fixed doc package (info documentation was incomplete).
- Relocated documentation to %_docdir/gcc-%version/.
- Relocated libgcj headers back to compiler-specific include directory.
- Renamed libf2c* to libg2c*.
- Libificated libg2c and libobjc packages.
- gcc: moved gccbug under update-alternatives control.
- c++: moved c++filt under update-alternatives control.
- libobjc: added libobjc_gc.* libraries.
- java: moved under update-alternatives control.
  (AKA: java now should be usable).
- Moved some manpages under update-alternatives control.
- Added buildreq substitution rules.
- Added buildreq ignore rules.
- Raised alternatives priority from 5 to 15.

* Mon Aug 19 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.2-alt2
- Synced with release tarball: 3.2 20020814 (release).
- Removed some patches - there are in tarball now.

* Tue Aug 13 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.2-alt1
- 3.2
- Added some Cooker & RawHide patches
- Fixed update-alternatives

* Mon Jun 24 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.1.1-alt1
- First build for Sisyphus
- Added some patches from CooKer
- Added patches from RH & Suse
